using Exferia_KairosPRO._1_Modelos.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using Exferia_Aplicacion.General;
using Exferia_KairosPRO._1_Modelos;
using Exferia_KairosPRO_EF;
using static Exferia_Aplicacion.General.Enumerados;
using System.Transactions;
using System.Data.SqlClient;
using System.Text;

namespace Exferia_KairosPRO._2_Datos
{
    public class KRS_PresenciasProgramadasTipos_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo> g_lst_INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            KairosProEntities obj_KairosProEntities = null;
            List<dynamic> lst_KRS = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Consulta.................................................................
                ConsultaRellenar_Listado(obj_KairosProEntities, _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //........................................................................

                if ((g_lst_INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo != null) && (g_lst_INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo.Count() > 0))
                {
                    lst_KRS = g_lst_INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_PresenciasProgramadasTipos_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return lst_KRS;
        }
        public override dynamic Obtener_RegistroListado(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            KairosProEntities obj_KairosProEntities = null;
            dynamic dnm_KRS = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_Listado(obj_KairosProEntities, _lst_CamposConRelacionABuscar, _lng_id, _lst_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //...............................................................

                if ((g_lst_INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo != null) && (g_lst_INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo.Count() > 0))
                {
                    dnm_KRS = g_lst_INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_PresenciasProgramadasTipos_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
            return dnm_KRS;
        }

        protected override void ConsultaRellenar_Listado(KairosProEntities _obj_KairosProEntities, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                //Datos del Padre si los tuviera .........................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";
                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    lng_Padre_id = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].VALOR;
                    str_Padre_Opcion = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].NOMBRE_CAMPO;
                }

                string str_SQL =
                    " SELECT " +
                        nameof(INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo.id) + " = " + nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.id) + "," +
                        nameof(INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo.codigoCliente) + " = " + nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.codigoCliente) + "," +
                        nameof(INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo.codigo) + " = " + nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.codigo) + "," +
                        nameof(INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo.descripcion) + " = " + nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.descripcion) + "," +
                        nameof(INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo.colorFondo) + " = " + nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.colorFondo) + "," +
                        nameof(INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo.colorLetra) + " = " + nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.colorLetra) +
                " FROM " + nameof(KRS_PresenciasProgramadasTipos) +
                " WHERE " +
                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.fechaBorrado) + " IS null AND " +
                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.codigoCliente) + "=@codigoCliente AND " +
                        (_lng_id > -1 ? (nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.id) + "=@id") : " 1 = 1 ");

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id),
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo = _obj_KairosProEntities.Database.SqlQuery<INTERNO_KRS_PresenciasProgramadasTipos_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_PresenciasProgramadasTipos_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }

        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(KairosProEntities _dbcontext, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {

        }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            
            return null;
        }
        protected override void ConsultaRellenar_F3(KairosProEntities _dbcontext, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {

        }
        #endregion

        #region Obtener
        private dynamic g_dnm_Modelo_Obtener = null;
        public override dynamic Obtener(long _lng_id)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                " SELECT distinct " +
                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.id) + "," +
                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.codigoCliente) + "," +
                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.codigo) + "," +
                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.descripcion) + "," +
                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.colorFondo) + "," +
                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.colorLetra) + "," +
                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.fechaBorrado) +
                " FROM " + nameof(KRS_PresenciasProgramadasTipos) +
                " WHERE " + nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.fechaBorrado) + " IS null AND " +
                            nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.id) + "=@id and " +
                            nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id),
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_KairosProEntities.Database.SqlQuery<KRS_PresenciasProgramadasTipos>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_PresenciasProgramadasTipos_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_CampoBusqueda, string _str_Filtro)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region MODELOS

        #region Modelo Simple
        private KRS_PresenciasProgramadasTipos g_mdl_KRS_PresenciasProgramadasTipos = null;
        public KRS_PresenciasProgramadasTipos Obtener_Modelo_Por_Id(long _lng_id, long _lng_CodigoCliente)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " +
                                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.id) + "=@id and " +
                                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id),
                     new SqlParameter("@codigoCliente",  _lng_CodigoCliente)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_PresenciasProgramadasTipos_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_KRS_PresenciasProgramadasTipos;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_KRS_PresenciasProgramadasTipos = obj_KairosProEntities.Database.SqlQuery<KRS_PresenciasProgramadasTipos>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_PresenciasProgramadasTipos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        #endregion

        #region Modelo Listado
        private List<KRS_PresenciasProgramadasTipos> g_lst_KRS_PresenciasProgramadasTipos= null;

        public List<KRS_PresenciasProgramadasTipos> Obtener_ModeloListado()
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.codigoCliente) + "=@codigoCliente and " +
                                        nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.fechaBorrado) + " is null "; 

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_PresenciasProgramadasTipos_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_KRS_PresenciasProgramadasTipos;
        }
        public List<KRS_PresenciasProgramadasTipos> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {

                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRS_PresenciasProgramadasTipos),
                                                                                            nameof(KRS_PresenciasProgramadasTipos.id),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_Ids);


                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " +
                                            nameof(KRS_PresenciasProgramadasTipos) + "." + nameof(KRS_PresenciasProgramadasTipos.codigoCliente) + "=@codigoCliente and " +
                                           str_Filtros_IDS;

                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));
                    object[] arr_Parametros = lst_Parametros.ToArray();

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     arr_Parametros);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_PresenciasProgramadasTipos_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_KRS_PresenciasProgramadasTipos;
        }

        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros)
        {
            KairosProEntities obj_KairosProEntities = null;
            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el modelo
                g_lst_KRS_PresenciasProgramadasTipos = obj_KairosProEntities.Database.SqlQuery<KRS_PresenciasProgramadasTipos>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_PresenciasProgramadasTipos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(KRS_PresenciasProgramadasTipos.id) + " , " +
                    nameof(KRS_PresenciasProgramadasTipos.codigoCliente) + " , " +
                    nameof(KRS_PresenciasProgramadasTipos.codigo) + " , " +
                    nameof(KRS_PresenciasProgramadasTipos.descripcion) + " , " +
                    nameof(KRS_PresenciasProgramadasTipos.colorFondo) + " , " +
                    nameof(KRS_PresenciasProgramadasTipos.colorLetra) + " , " +
                    nameof(KRS_PresenciasProgramadasTipos.fechaBorrado) +
                " FROM " + nameof(KRS_PresenciasProgramadasTipos);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                KRS_PresenciasProgramadasTipos mdl_KRS_PresenciasProgramadasTipos_AGrabar = (KRS_PresenciasProgramadasTipos)_mdl_obj;
                KRS_PresenciasProgramadasTipos mdl_KRS_PresenciasProgramadasTipos_DatosViejos = new KRS_PresenciasProgramadasTipos();

                KRS_PresenciasProgramadasTipos mdl_KRS_PresenciasProgramadasTipos_Final = Obtener_Modelo_Por_Id(mdl_KRS_PresenciasProgramadasTipos_AGrabar.id, Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO);

                if (mdl_KRS_PresenciasProgramadasTipos_Final != null )
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;
                    
                    //Validado el codigo del cliente, se lo asignamos antes de grabar
                    mdl_KRS_PresenciasProgramadasTipos_AGrabar.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Datos viejos para la trazabilidar
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_PresenciasProgramadasTipos_Final, mdl_KRS_PresenciasProgramadasTipos_DatosViejos, false, false);

                    //Cargar los Datos del modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_PresenciasProgramadasTipos_AGrabar, mdl_KRS_PresenciasProgramadasTipos_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(KRS_PresenciasProgramadasTipos) +
                                            " SET " +
                                                nameof(KRS_PresenciasProgramadasTipos.codigoCliente) + "=@codigoCliente," +
                                                nameof(KRS_PresenciasProgramadasTipos.codigo) + "=@codigo," +
                                                nameof(KRS_PresenciasProgramadasTipos.descripcion) + "=@descripcion," +
                                                nameof(KRS_PresenciasProgramadasTipos.colorFondo) + "=@colorFondo," +
                                                nameof(KRS_PresenciasProgramadasTipos.colorLetra) + "=@colorLetra," +
                                                nameof(KRS_PresenciasProgramadasTipos.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(KRS_PresenciasProgramadasTipos.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigoCliente",  mdl_KRS_PresenciasProgramadasTipos_Final.codigoCliente),
                        new SqlParameter("@codigo",  mdl_KRS_PresenciasProgramadasTipos_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_KRS_PresenciasProgramadasTipos_Final.descripcion),
                        mdl_KRS_PresenciasProgramadasTipos_Final.colorFondo != null
                            ?   new SqlParameter("@colorFondo", mdl_KRS_PresenciasProgramadasTipos_Final.colorFondo)
                            :   new SqlParameter("@colorFondo",  DBNull.Value),
                        mdl_KRS_PresenciasProgramadasTipos_Final.colorLetra != null
                            ?   new SqlParameter("@colorLetra", mdl_KRS_PresenciasProgramadasTipos_Final.colorLetra)
                            :   new SqlParameter("@colorLetra",  DBNull.Value),
                         mdl_KRS_PresenciasProgramadasTipos_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_KRS_PresenciasProgramadasTipos_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_KRS_PresenciasProgramadasTipos_Final.id),
                    };
                    #endregion

                    //Update
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_KRS_PresenciasProgramadasTipos_Final.id;
                }
                else
                {
                    mdl_KRS_PresenciasProgramadasTipos_Final = new KRS_PresenciasProgramadasTipos();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Validado el codigo del cliente, se lo asignamos antes de grabar
                    mdl_KRS_PresenciasProgramadasTipos_AGrabar.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Cargar los Datos del modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_PresenciasProgramadasTipos_AGrabar, mdl_KRS_PresenciasProgramadasTipos_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(KRS_PresenciasProgramadasTipos) +
                                                " (" +
                                                        nameof(KRS_PresenciasProgramadasTipos.codigoCliente) + "," +
                                                        nameof(KRS_PresenciasProgramadasTipos.codigo) + "," +
                                                        nameof(KRS_PresenciasProgramadasTipos.descripcion) + "," +
                                                        nameof(KRS_PresenciasProgramadasTipos.colorFondo) + "," +
                                                        nameof(KRS_PresenciasProgramadasTipos.colorLetra) + "," +
                                                        nameof(KRS_PresenciasProgramadasTipos.fechaBorrado) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(KRS_PresenciasProgramadasTipos.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@codigoCliente," +
                                                    "@codigo," +
                                                    "@descripcion," +
                                                    "@colorFondo," +
                                                    "@colorLetra," +
                                                    "@fechaBorrado" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigoCliente",  mdl_KRS_PresenciasProgramadasTipos_Final.codigoCliente),
                        new SqlParameter("@codigo",  mdl_KRS_PresenciasProgramadasTipos_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_KRS_PresenciasProgramadasTipos_Final.descripcion),
                        mdl_KRS_PresenciasProgramadasTipos_Final.colorFondo != null
                            ?   new SqlParameter("@colorFondo", mdl_KRS_PresenciasProgramadasTipos_Final.colorFondo)
                            :   new SqlParameter("@colorFondo",  DBNull.Value),
                        mdl_KRS_PresenciasProgramadasTipos_Final.colorLetra != null
                            ?   new SqlParameter("@colorLetra", mdl_KRS_PresenciasProgramadasTipos_Final.colorLetra)
                            :   new SqlParameter("@colorLetra",  DBNull.Value),
                         mdl_KRS_PresenciasProgramadasTipos_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_KRS_PresenciasProgramadasTipos_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_KairosProEntities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRS_PresenciasProgramadasTipos), mdl_KRS_PresenciasProgramadasTipos_DatosViejos, mdl_KRS_PresenciasProgramadasTipos_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_KairosProEntities);
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_PresenciasProgramadasTipos_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            bool bol_ActualizarFechaBorrado = false;//Este campo se utiliza por si no se puede borrar, que actualice la fecha de borrado

            // Se utiliza la transaccion por la llamada al procedimiento de almacenado
            using (TransactionScope transaccion_SQL = new TransactionScope(TransactionScopeOption.Required))
            {
                try
                {

                    obj_KairosProEntities = new KairosProEntities();
                    obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                    // Ver si existe ######################################################################
                    KRS_PresenciasProgramadasTipos mdl_KRS_PresenciasProgramadasTipos = Obtener_Modelo_Por_Id(_lng_id, Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO);
                    //######################################################################################

                    if (mdl_KRS_PresenciasProgramadasTipos != null)
                    {
                        //Se intenta borrar, si diera un error porque esta relacaionado se graba la fecha de baja
                        try
                        {
                            #region Delete
                            string str_SQL_Delete = " DELETE FROM  " + nameof(KRS_PresenciasProgramadasTipos) +
                                                    " WHERE " +
                                                        nameof(KRS_PresenciasProgramadasTipos.id) + "=@id and " +
                                                        nameof(KRS_PresenciasProgramadasTipos.codigoCliente) + "=@codigoCliente ";
                            //Parametros
                            object[] arr_Parametros_Delete = new object[]
                            {
                                new SqlParameter("@id", _lng_id),
                                new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                            };
                            #endregion

                            //Delete
                            obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                            // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                            USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRS_PresenciasProgramadasTipos), null, mdl_KRS_PresenciasProgramadasTipos, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_KairosProEntities);
                        }
                        catch (Exception ex)
                        {
                            var sqlException = ex.GetBaseException() as SqlException;
                            if (sqlException != null)
                            {
                                if (sqlException.Errors.Count > 0)
                                {
                                    switch (sqlException.Errors[0].Number)
                                    {
                                        case Control_Errores.G_INT_ERRORCONTROLADO_BORRAR_CONFLICTO_CLAVEFORANEA: // Foreign Key violation
                                            bol_ActualizarFechaBorrado = true;
                                            break;
                                        default:
                                            throw;
                                    }
                                }
                            }
                            else
                            {
                                throw;
                            }
                        }
                    }


                    // Actualizar la fecha de baja , al no poder borrarlo por tener relaciones
                    if (bol_ActualizarFechaBorrado)
                    {

                        #region Update
                        string str_SQL_Update = " UPDATE " + nameof(KRS_PresenciasProgramadasTipos) +
                                                    " SET " +
                                                    nameof(KRS_PresenciasProgramadasTipos.fechaBorrado) + "=@fechaBorrado " +
                                                 " WHERE " +
                                                        nameof(KRS_PresenciasProgramadasTipos.id) + "=@id and " +
                                                        nameof(KRS_PresenciasProgramadasTipos.codigoCliente) + "=@codigoCliente ";
                        //Parametros
                        object[] arr_Parametros_Update = new object[]
                        {
                            new SqlParameter("@fechaBorrado",  DateTime.Now),
                            new SqlParameter("@id", _lng_id),
                            new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                        };
                        #endregion

                        //Update
                        obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                        // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                        USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRS_PresenciasProgramadasTipos), null, mdl_KRS_PresenciasProgramadasTipos, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_KairosProEntities);
                    }

                    // Devolver también el Objeto
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;

                    // Se termina la Transaccion Correctamente
                    transaccion_SQL.Complete();
                }
                catch (Control_Errores)
                {
                    throw;
                }
                catch (Exception ex)
                {
                    throw new Control_Errores("", ex, nameof(KRS_PresenciasProgramadasTipos_Datos) + "/" + nameof(Borrar), true);
                }
                finally
                {
                    obj_KairosProEntities.Database.Connection.Close();
                    obj_KairosProEntities.Dispose();

                    // Finalizar transaccion
                    transaccion_SQL.Dispose();

                    
                }
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}
